/******************************************************************************
                                   FMT22.TTP
                       Written for Runtime by Les Kneeling

This is a disk formatter which not only fits into 22 lines of code but also 
offers a range of non-standard formats - 9 or 10 sectors per track and 80 to
82 tracks per side on single and double sided disks.

Parameters:
    Disk drive: 0 - A, 1 - B
    Sides:      1 - single sided, 2 - double
    Tracks:     80, 81, 82
    Sectors:    9, 10

Type the parameters into the TTP dialog separated by spaces,
    e.g. 0 2 80 9 for a standard double sided disk.

All four parameters are required. There is no error checking. I would not 
suggest asking for more than 82 tracks unless you know that your drive can
handle it. It is certainly not worth asking for more than ten sectors per
track.
******************************************************************************/
#include <osbind.h>
main(argc, argv ) int argc;char **argv;{
register int count;
static unsigned char fmtbuf[20000];
unsigned int param[6], unit, side, tracks, spt, spd;
if( argc < 4 ) { Cconws("Need drive, sides, tracks, sectors per track");
                 Cconin(); exit(1);}
for(count=1;count<argc;count++) sscanf(argv[count],"%d",&param[count]);
for(side= 0; side<param[2];side++ ) 
    {   Cconout( 27 );  Cconout( 'H' );
    for(count=0;count<param[3];count++) 
      if(Flopfmt(fmtbuf,0l,param[1],param[4],count,side,1,0x87654321L,0xe5e5))
            { Cconws( "Format Error" ); exit(1);    } 
      else Cconout( 'A' + side ); }
for( count=0; count < 512 * param[4]; count++ ) fmtbuf[count]=0;
Flopwr( fmtbuf, 0l, param[1], 1, 0, 0, param[4] );
Flopwr( fmtbuf, 0l, param[1], 1, 1, 0, param[4] );
Protobt( fmtbuf, 0x1000001L, param[2] + 1, 0 );
fmtbuf[24] = param[4]; fmtbuf[25] = 0; spd = param[2] * param[3] * param[4];
fmtbuf[19]= spd & 0xff; fmtbuf[20] = spd>>8;
Flopwr( fmtbuf, 0l, param[1], 1, 0, 0, 1 );
}
