/*--------------------------------------------------------------------------
  FORM.PRG allows you to create and test form alert definitions before
  automatically creating and saving the C source code to reproduce them
  in your own programs.
  FORM.C and FORMRSC.C should be compiled separately and combined at
  link time.

  By Les Kneeling, 1989
--------------------------------------------------------------------------*/
#include <stdio.h>
#include <gemdefs.h>
#include <obdefs.h>
#include <osbind.h>
#include <strings.h>
#include <define.h>

#include "form.h";                  /* The object definitions are here  */

extern OBJECT *rs_trindex[];        /* Used for the code which replaces
                                       the resource file                */
OBJECT *dialog;
char temp[255], filespec[255];
int icon_number = 0, button_number = 0;

main()
{
int x, y, w, h;
int event;

appl_init();                        /* Initialise ROMS                  */
graf_mouse( ARROW, 0l );            /* Get rid of bee mouse form        */
fix_objects();                      /* Twiddle to make resources work
                                       (see RSCTOC documentation)       */
dialog = rs_trindex[0];             /* Don't use RSRC_GADDR!            */
form_center( dialog, &x, &y, &w, &h );
                                    /* Back to normal now               */
form_dial( FMD_START, 0, 0, 0, 0, x, y, w, h );
init_dial();
objc_draw( dialog, 0, MAX_DEPTH, x, y, w, h );
do  {                               /* Handle events                    */
    event = form_do( dialog, STRING1 );
    
    switch( event ){
        case TEST:                  /* Test form alert definition       */
            test_alert();
            objc_change( dialog, TEST, 0, x, y, w, h, NORMAL, 1 );
                                    /* Whole dialog will redraw         */
            break;
        case SAVE_C:                /* Save C source code               */
            dialog[SAVE_C].ob_state &= ~SELECTED;
                                    /* Reset the button to normal       */
            save_source( x, y, w, h);
            break;
        }
    objc_draw( dialog, LIMITER, 0, x, y, w, h );
    }while( event != FINISHED );
appl_exit();
}

init_dial()                         /* Set up dialog strings            */
{
*((TEDINFO *)dialog[STRING1].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[STRING2].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[STRING3].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[STRING4].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[STRING5].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[BUTTON1].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[BUTTON2].ob_spec)->te_ptext = 0;
*((TEDINFO *)dialog[BUTTON3].ob_spec)->te_ptext = 0;
dialog[LIMITER].ob_width = 1;
}

test_alert()                        /* Test form alert defintion        */
{
if( transfer() )
    form_alert( button_number, temp );
}

save_source( x, y, w, h )           /* Save the C source code           */
int x, y, w, h;
{
FILE *stream;
if( transfer() )
    {
    if( select( filespec ) )
        {
        objc_draw( dialog, 0, MAX_DEPTH, x, y, w, h );

        stream = fopen( filespec, "w" );
        
        if( stream != 0l )
            {
            graf_mouse( HOURGLASS, 0l );
            fprintf( stream, "form_alert( %d, %c%s%c );", button_number,
                            0x22, temp, 0x22 );
            fclose( stream );
            graf_mouse( ARROW, 0l );
            }
        }
    else
        objc_draw( dialog, 0, MAX_DEPTH, x, y, w, h );
    }
}

transfer()                          /* Create source code from the      */
{                                   /* dialog box                       */
int reslt = FALSE;

if( dialog[PLING].ob_state & SELECTED )
    icon_number = 1;
else if( dialog[Q_MARK].ob_state & SELECTED )
    icon_number = 2;
else if( dialog[STOP].ob_state & SELECTED )
    icon_number = 3;
else icon_number = 0;

if( dialog[DEF1].ob_state & SELECTED )
    if( strlen( ((TEDINFO *)dialog[BUTTON1].ob_spec)->te_ptext) > 0 )
        button_number = 1;
if( dialog[DEF2].ob_state & SELECTED )
    if( strlen( ((TEDINFO *)dialog[BUTTON2].ob_spec)->te_ptext) > 0 )
        button_number = 2;
if( dialog[DEF3].ob_state & SELECTED )
    if( strlen( ((TEDINFO *)dialog[BUTTON3].ob_spec)->te_ptext) > 0 )
        button_number = 3;
else button_number = 0;

sprintf( temp, "[%d][", icon_number );
if( strlen( ((TEDINFO *)dialog[STRING1].ob_spec)->te_ptext) > 0 )
    {
    strcat( temp, ((TEDINFO *)dialog[STRING1].ob_spec)->te_ptext );
    if( strlen( ((TEDINFO *)dialog[STRING2].ob_spec)->te_ptext) > 0 )
        {
        strcat( temp, "|");
        strcat( temp, ((TEDINFO *)dialog[STRING2].ob_spec)->te_ptext );
        if( strlen( ((TEDINFO *)dialog[STRING3].ob_spec)->te_ptext) > 0 )
            {
            strcat( temp, "|");
            strcat( temp, ((TEDINFO *)dialog[STRING3].ob_spec)->te_ptext );
            if( strlen( ((TEDINFO *)dialog[STRING4].ob_spec)->te_ptext) > 0 )
                {
                strcat( temp, "|");
                strcat( temp, ((TEDINFO *)dialog[STRING4].ob_spec)->te_ptext );
                if( strlen( ((TEDINFO *)dialog[STRING5].ob_spec)->te_ptext) > 0 
)
                    {
                    strcat( temp, "|");
                    strcat( temp, ((TEDINFO *)dialog[STRING5].ob_spec)->te_ptext
 );
                    }
                }
            }
        }
    strcat( temp, "]" );
    if( strlen( ((TEDINFO *)dialog[BUTTON1].ob_spec)->te_ptext) > 0 )
        {
        reslt = TRUE;
        strcat( temp, "[");
        strcat( temp, ((TEDINFO *)dialog[BUTTON1].ob_spec)->te_ptext );
        if( strlen( ((TEDINFO *)dialog[BUTTON2].ob_spec)->te_ptext) > 0 )
            {
            strcat( temp, "|");
            strcat( temp, ((TEDINFO *)dialog[BUTTON2].ob_spec)->te_ptext );
            }
        if( strlen( ((TEDINFO *)dialog[BUTTON3].ob_spec)->te_ptext) > 0 )
            {
            strcat( temp, "|");
            strcat( temp, ((TEDINFO *)dialog[BUTTON3].ob_spec)->te_ptext );
            }
        strcat( temp, "]" );
        }
    }
return reslt;
}

select( filespec )                  /* Show file selector box for file  */
char *filespec;                     /* save routine                     */
{
static char path[160];
static char name[15];
int button, count;
static int first = TRUE;

if( first )                     /* been here before?                 */
    {
    first = FALSE;              /* if this is the first time through */
    strcpy( name, "" );         /* clear the text in "name"          */
    sprintf( path, "%c:\\*.C", Dgetdrv() + 'A' );
    }
else
    strcat( path, "*.C" );

fsel_input( path, name, &button );  /* choose file                  */

count = strlen( path );         /* get rid of the wildcards         */
while( path[count] != '\\' )
    count--;
path[count+1] = 0;

if( button == 1 )
    sprintf( filespec, "%s%s",path, name );         
return button;
}
