 SECTION TEXT

 ; 40 TRACK DISK DRIVER (FOR DISK B)
 ; VERSION 1.0 (18.06.91)

 ; MEMORY SHRINK

	MOVEA.L A7,A5
	MOVEA.L #PRG_STACK,A7
 	MOVEA.L 4(A5),A5         ; GET BASE PAGE ADRESS
             MOVE.L  $C(A5),D0        ; LENGTH OF TEXT
             ADD.L   $14(A5),D0       ; LENGTH OF DATA 
	ADD.L   $1C(A5),D0       ; LENGTH OF BSS
	ADDI.L  #$100,D0         ; LENGTH OF BASE PAGE
	MOVE.L  D0,PRG_LENGTH

	MOVE.L  D0,-(A7)   
             MOVE.L  A5,-(A7)
             MOVE.W  #0,-(A7)
             MOVE.W  #$4A,-(A7)
             TRAP    #1
             LEA     $C(A7),A7

 ; PROTECT NAME

	LEA     NAME,A0
             CLR.L   D0
PROTECT_LOOP:MOVE.B  (A0),D0
             TST.B   D0
	BEQ.S   GET_REZ
	ADD.L   D0,PROTECT
             ADDQ.L  #1,A0
	BRA.S   PROTECT_LOOP

 ; GET SCREEN RESOLUTION

GET_REZ:	MOVE.W  #$4,-(A7)
	TRAP    #14
	ADDQ.L  #2,A7

             TST.W   D0
	BNE.S   PRINT_MESS

             SUB.B   #20,COLUMN
             SUB.B   #20,COLUMN_1

 ; WRITE BEGIN MESSAGE

PRINT_MESS:	PEA     BEG_MESSAGE
	MOVE.W  #$9,-(A7)
	TRAP    #1
	ADDQ.L  #6,A7

 ; DELEY LOOP

             MOVE.W  #-1,D1
DELEY_1:	MOVE.W  #12,D0
DELEY:	DBRA    D0,DELEY
             DBRA    D1,DELEY_1

 ; GET BIOS PARAMETR BLOCK

GET_BPB:     MOVE.W  #0,-(A7)         ; DEVICE NUMBER
             MOVE.W  #7,-(A7)
             TRAP    #$D
             ADDQ.L  #4,A7

             MOVE.L  D0,BPB
             move.l  D0,DSB_B
             add.l   #$32,DSB_B
             MOVE.L  A0,DISK_ARR

             TST.L   D0
             BNE.S   RESTORE_MESS

 ; WRITE WARNING MESSAGE

	PEA     WARNING_MESS
	MOVE.W  #$9,-(A7)
	TRAP    #1
	ADDQ.L  #6,A7

 ; GET A KEY

	MOVE.W  #$7,-(A7)
             TRAP    #1
	ADDQ.L  #2,A7

             CMPI.W  #$1B,D0
	BNE.S   GET_BPB

	CLR.W   -(A7)
	TRAP    #1
	ADDQ.L  #2,A7

 ; RESTORE OLD BACKGROUND & CHARACTER COLOR

RESTORE_MESS:PEA     RESTORE_COL
	MOVE.W  #$9,-(A7)
	TRAP    #1
	ADDQ.L  #6,A7

 ; SET SUPERVISOR MODE

             CLR.L   -(A7)
             MOVE.W  #$20,-(A7)
             TRAP    #1
             ADDQ.L  #6,A7

             MOVE.L  D0,SAVESTACK

 ; GET DISK BUFFER

             MOVE.L  $4C6,DISK_BUF

	MOVE.W  SR,-(A7)
	MOVE.W  #$2700,SR

 ; SET NEW XBIOS (TRAP#14) VECTOR

             MOVE.L  $B8,OLD_XBIOS
             MOVE.L  $B8,STD_XBIOS+2
             LEA     NEW_XBIOS,A0
             MOVE.L  A0,$B8

 ; SET NEW HDV_RW VECTOR

             MOVE.L  $476,OLD_HDV_RW
             MOVE.L  $476,D0
             EORI.L  #$98B,D0
             MOVE.L  PROTECT,D1
             EOR.L   D1,D0
             MOVE.L  D0,OLD_RWABS+2
             LEA     RWABS,A0
             MOVE.L  A0,$476

 ; SET NEW HDV_BOOT VECTOR

;             MOVE.L  $47A,OLD_HDV_BOOT
;             LEA     BOOTLOAD,A0
;             MOVE.L  A0,$47A

 ; SET JUMP TO HDV_MEDIACH VECTOR

             MOVE.L  $47E,MEDIACH+2

	MOVE.W  (A7)+,SR

 ; SET NORMAL MODE

             MOVE.L  SAVESTACK,-(A7)
             MOVE.W  #$20,-(A7)
             TRAP    #1
             ADDQ.L  #6,A7

 ; MAKE PTERM_RES

             CLR.W   -(A7)
             MOVE.L  PRG_LENGTH,-(A7)
             MOVE.W  #$31,-(A7)
             TRAP    #1
             ADDQ.L  #8,A7

 ; ************************
 ; *** NEW XBIOS VECTOR ***
 ; ************************

NEW_XBIOS:   MOVEA.L $4A2,A1
             MOVE.W  (A7)+,D0
             MOVE.W  D0,-(A1)
             MOVE.L  (A7)+,-(A1)
             MOVEM.L D3-D7/A3-A7,-(A1)
             MOVE.L  A1,$4A2
             BTST    #$D,D0
             BNE.S   NOT_USER
             MOVE.L  USP,A7

NOT_USER:    MOVEA.L DISK_ARR,A4
             SUBA.L  A5,A5  
             MOVE.W  (A7)+,D0

             CMPI.W  #$12,D0
             BNE.S   COMP_FLOPRD

             BSR     PROTOBT
             BRA.S   RET_XBIOS

COMP_FLOPRD: CMPI.W  #1,8(A7)
             BNE.S   JUMP_XBIOS

             CMPI.W  #$8,D0
             BNE.S   COMP_FLOPWR

             BSR     FLOPRD
             BRA.S   RET_XBIOS

COMP_FLOPWR: CMPI.W  #$9,D0
             BNE.S   COMP_FLOPFMT

             BSR     FLOPWR
             BRA.S   RET_XBIOS

COMP_FLOPFMT:CMPI.W  #$A,D0
             BNE.S   COMP_FLOPVER

             BSR     FLOPFMT
             BRA.S   RET_XBIOS

COMP_FLOPVER:CMPI.W  #$13,D0
             BNE.S   JUMP_XBIOS

             BSR     FLOPVER

RET_XBIOS:   MOVEA.L $4A2,A1
             MOVEM.L (A1)+,D3-D7/A3-A7
             MOVE.L  (A1)+,-(A7)
             MOVE.W  (A1)+,-(A7)
             MOVE.L  A1,$4A2
             RTE

JUMP_XBIOS:  MOVEA.L $4A2,A1
             MOVEM.L (A1)+,D3-D7/A3-A7
             MOVE.L  (A1)+,-(A7)
             MOVE.W  (A1)+,-(A7)
             MOVE.L  A1,$4A2
STD_XBIOS:   JMP     0.L

 ; ************************************************************

 ; Subroutine Copy Disk Sector

COPY_SECT:   MOVEA.L 4(A7),A0             ; source address
             MOVEA.L 8(A7),A1             ; destanation address
             MOVE.W  #$3F,D0              ; (63+1)*8 = 512 bytes
COPY_8:      MOVE.B  (A0)+,(A1)+ 
             MOVE.B  (A0)+,(A1)+
             MOVE.B  (A0)+,(A1)+
             MOVE.B  (A0)+,(A1)+          ; copy 8 bytes
             MOVE.B  (A0)+,(A1)+
             MOVE.B  (A0)+,(A1)+
             MOVE.B  (A0)+,(A1)+
             MOVE.B  (A0)+,(A1)+    
             DBRA    D0,COPY_8            ; next 8 bytes 
             RTS
 
 ; hard disk initialization

HD_INIT:     MOVE.L  $46A,-(A7)           ; HDV_INIT on stack
             RTS                          ; jump to routine

 ; *********************************
 ; *** BIOS Media change routine ***
 ; *********************************

;MEDIACH:     LINK    A6,#0                
;             MOVEM.L D6-D7/A4-A5,-(A7)
;             MOVEA.L DISK_ARR,A4       
;             CMPI.W  #2,8(A6)             ; drive number
;             BLT.S   FC118E               ; <2 ?
;             MOVEQ   #-$F,D0              ; unknown device !
;             BRA.S   MEDCH_QUIT           ; error
;FC118E       MOVE.W  8(A6),D7             ; drive number
;             MOVEA.W D7,A5
;FC1194       ADDA.L  BPB,A5               ; $755A
;             SUBA.L  #$16,A5
;             CMPI.B  #2,(A5)
;             BNE.S   FC11A4
;             MOVEQ   #2,D0
;             BRA.S   MEDCH_QUIT
;FC11A4       MOVEA.L DISK_ARR,A0          ; $9FA status of disk change
;             TST.B   0(A0,D7.W)
;             BEQ.S   FC11B4
;             MOVE.B  #1,(A5)
;FC11B4       MOVE.L  $466,D0              ; ++ 200 hz
;             MOVEA.W D7,A1
;             ADDA.L  A1,A1
;             ADDA.L  A1,A1
;             ADDA.L  DISK_ARR,A1          ; $9FC time of last floppy access
;             ADDQ.L  #2,A1
;             MOVE.L  (A1),D1
;             SUB.L   D1,D0
;             CMP.L   ACCTIM,D0             ; $2A46 maxacctim  
;             BGE.S   FC11D6
;             CLR.W   D0
;             BRA.S   MEDCH_QUIT
;FC11D6       MOVE.B  (A5),D0
;             EXT.W   D0
;MEDCH_QUIT:  TST.L   (A7)+
;             MOVEM.L (A7)+,D7/A4-A5
;             UNLK    A6
;             RTS

;JMP_MEDIACH: MOVEM.L (A7)+,D6-D7/A4-A5
;             UNLK    A6
;OLD_MEDCH:   JMP     0.L
   
 ; Test for Disk Change

FC11E4       LINK    A6,#0
             MOVEM.L D4-D7/A4-A5,-(A7)
             MOVE.W  8(A6),D6          ; drive namber
             MOVE.W  D6,D0
             ASL.W   #5,D0             ; times 32
             EXT.L   D0
             MOVEA.L D0,A5
             ADDA.L  BPB,A5            ; $7570 plus address BPB
             MOVE.W  D6,(A7)
MEDIACH:     JSR     0.L               ; test media change
             MOVE.W  D0,D7
             CMP.W   #2,D7             ; changed ?
             BNE.S   FC1216            ; no
             MOVE.W  D7,D0
             BRA     FC12AC
             BRA     FC12AA
FC1216       CMP.W   #1,D7             ; diskette changed
             BNE     FC12AA            ; no
FC121E       MOVE.W  #1,(A7)           ; read sector (boot sector)
             CLR.L   -(A7)             ; side 0, track 0
             MOVE.W  #1,-(A7)          ; sector 1
             MOVE.W  D6,-(A7)          ; drive number
             CLR.L   -(A7)             ; filler
             MOVE.L  DISK_BUF,-(A7)    ; $16DA disk buffer   
             JSR     FLOPRD           
             ADDA.L  #$10,A7           ; correct stack pointer
             MOVE.L  D0,D5             ; save error number
             TST.L   D5                ; ok ?
             BGE.S   FC1256            ; yes
             MOVE.W  D6,(A7)
             MOVE.L  D5,D0             ; error number
             MOVE.W  D0,-(A7)
             JSR     EVT_CRITIC        ; pass to critical error handler
             ADDQ.L  #2,A7             ; correct stack pointer
             MOVE.L  D0,D5             ; error number
FC1256       CMP.L   #$10000,D5        ; retry ?
             BEQ.S   FC121E            ; yes, try again
             TST.L   D5                ; error code
             BGE.S   FC1266            ; ok ?
             MOVE.L  D5,D0             ; else error number
             BRA.S   FC12AC            ; error exit
FC1266       CLR.W   D7                ; clear media change status
             BRA.S   FC1286
FC126A       MOVEA.L DISK_BUF,A0       ; $16DA address of disk buffer
             MOVE.B  8(A0,D7.W),D0     ; serial number
             EXT.W   D0
             MOVE.B  $1C(A5,D7.W),D1   ; compare with old value
             EXT.W   D1
             CMP.W   D1,D0             ; match
             BEQ.S   FC1284            ; yes
             MOVEQ   #2,D0             ; media changed
FC1282       BRA.S   FC12AC            ; error exit
FC1284       ADDQ.W  #1,D7             ; next byte or serial number
FC1286       CMP.W   #3,D7             ; all three bytes tested ?
             BLT.S   FC126A            ; no
             MOVEA.W D6,A0             ; drive number
             ADDA.L  DISK_ARR,A0       ; $9FA status of disk change
             MOVEA.W D6,A1             ; drive number
             ADDA.L  DISK_ARR,A1       ; $9F8 write protect status
             SUBQ.L  #$2,A1 
             MOVE.B  (A1),(A0)         ; accept
             BNE.S   FC12AA
             MOVEA.W D6,A0
             ADDA.L  BPB,A0            ; $755A
             SUBA.L  #$16,A0
             CLR.B   (A0)
FC12AA       CLR.W   D0                ; ok
FC12AC       TST.L   (A7)+
             MOVEM.L (A7)+,D5-D7/A4-A5
             UNLK    A6
             RTS

 ; *******************************
 ; *** RWABS function (FC12B6) ***
 ; *******************************

RWABS:       LINK    A6,#0
             MOVEM.L D5-D7/A4,-(A7)
             MOVEA.L DISK_ARR,A4
             MOVE.W  $12(A6),D7           ; drive number
             MOVE.W  D7,D0                
             CMP.W   #1,D0                
             BNE.S   JMP_RWABS            ; is B drive ?
             TST.W   $4A6                 ; number of floppy
             BNE.S   FC12DC
             MOVEQ   #-2,D0
             BRA.S   RWABS_QUIT
FC12DC       TST.L   $A(A6)               ; test buffer address
             BNE.S   FC12F8               ; =0 ?
             MOVE.W  $E(A6),D0            ; get number of sectors
             MOVEA.L BPB,A1               ; $755A
             SUBA.L  #$16,A1
             MOVEA.W $12(A6),A2           ; get drive number
             ADDA.L  A2,A1
             MOVE.B  D0,(A1)
             CLR.L   D0
             BRA.S   RWABS_QUIT
FC12F8       CMPI.W  #2,8(A6)             ;  r/w flag
             BGE.S   FC131C
             MOVE.W  D7,(A7)
             BSR     FC11E4               ; test media change
             EXT.L   D0
             MOVE.L  D0,D6                ; save status
             TST.L   D6
             BEQ.S   FC131C
             CMP.L   #2,D6                ; disk changed ?
             BNE.S   FC1318               ; no, continue
             MOVEQ   #-$E,D6              ; media change error
FC1318       MOVE.L  D6,D0
             BRA.S   RWABS_QUIT           ; then quit
FC131C       MOVE.W  $E(A6),(A7)          ; count
             MOVE.W  D7,-(A7)             ; drive number
             MOVE.W  $10(A6),-(A7)        ; start sector
             MOVE.L  $A(A6),-(A7)         ; buffer
             MOVE.W  8(A6),-(A7)          ; r/w flag
             BSR.S   FLOPRW               ; jump to FLOPRW
             ADDA.L  #$A,A7               ; correct stack
RWABS_QUIT:  TST.L   (A7)+ 
             MOVEM.L (A7)+,D6-D7/A4
             UNLK    A6
             RTS

JMP_RWABS:   MOVEM.L (A7)+,D5-D7/A4
             UNLK    A6
OLD_RWABS:	JMP     0.L

 ; ******************************************
 ; *** FLOPRW read/write sectors (FC1340) ***
 ; ******************************************

FLOPRW:      LINK    A6,#-6
             MOVEM.L D2-D7/A5,-(A7)
             MOVE.W  $10(A6),D0           ; drive number
             ASL.W   #5,D0                ; times 32
             EXT.L   D0
             MOVEA.L D0,A5
             ADDA.L  BPB,A5               ; $7570 plus BPB base address
             BTST    #0,$D(A6)            ; buffer address not even ?
             BNE.S   FC1364               ; yes
             CLR.W   D0                   ; clear oddflag
             BRA.S   FC1366
FC1364       MOVEQ   #1,D0                ; set oddflag
FC1366       MOVE.W  D0,-2(A6)            ; and save
             TST.W   $16(A5)              ; dspc set ?
             BNE.S   FC137A               ; yes
             MOVEQ   #9,D0                ; else take 9
             MOVE.W  D0,$16(A5)           ; as dspt
             MOVE.W  D0,$18(A5)           ; and dspc
FC137A       BRA     FC14FC
FC137E       TST.W   -2(A6)               ; oddflag set ?
             BEQ.S   FC138C               ; no
             MOVE.L  DISK_BUF,D0          ; $16DA - sector buffer 
             BRA.S   FC1390
FC138C       MOVE.L  $A(A6),D0            ; get buffer address
FC1390       MOVE.L  D0,-6(A6)            ; and save
             MOVE.W  $E(A6),D6            ; recno, logical sector number
             EXT.L   D6                   
             DIVS    $16(A5),D6           ; div by dspc yields track number
             MOVE.W  $E(A6),D4            ; recno, logical sector number
             EXT.L   D4
             DIVS    $16(A5),D4           ; div by dspc,sector per track
             SWAP    D4                   ; remainder of div as sector numb 
             CMP.W   $18(A5),D4           ; compare with dspt
             BGE.S   FC13B4               ; greater than or equal ?
             CLR.W   D5                   ; side 0
             BRA.S   FC13BA
FC13B4       MOVEQ   #1,D5                ; side 1
             SUB.W   $18(A5),D4           ; subtract dspt 
FC13BA       TST.W   -2(A6)               ; oddflag set ?
             BEQ.S   FC13C4               ; no
             MOVEQ   #1,D3                ; set counter to 1
             BRA.S   FC13DC
FC13C4       MOVE.W  $18(A5),D0           ; dspt
             SUB.W   D4,D0                ; minus sector number 
             CMP.W   $12(A6),D0           ; compare with number of sectors
             BGE.S   FC13D8               ; greater or equal 
             MOVE.W  $18(A5),D3           ; dspt
             SUB.W   D4,D3                ; minus sector number eq. counter
             BRA.S   FC13DC
FC13D8       MOVE.W  $12(A6),D3           ; number of sectors as counter
FC13DC       ADDQ.W  #1,D4                ; inc. sector # (ist number is 1)
FC13DE       BTST    #0,9(A6)             ; test read - write flag
             BEQ     FC1466               ; read
             MOVE.L  -6(A6),D0            ; buffer pointer
             CMP.L   $A(A6),D0            ; equals buffer address
             BEQ.S   FC1402               ; yes
             MOVE.L  -6(A6),(A7)          ; source address
             MOVE.L  $A(A6),-(A7)         ; destination address
             JSR     COPY_SECT            ; copy a sector
             ADDQ.L  #4,A7                ; correct stack pointer
FC1402       MOVE.W  D3,(A7)              ; number of sectors
             MOVE.W  D5,-(A7)             ; side number
             MOVE.W  D6,-(A7)             ; track 
             MOVE.W  D4,-(A7)             ; sector
             MOVE.W  $10(A6),-(A7)        ; drive
             CLR.L   -(A7)                ; filler
             MOVE.L  -6(A6),-(A7)         ; sector buffer
             JSR     FLOPWR               ; read sector ???
             ADDA.L  #$10,A7              ; correct stack
             MOVE.L  D0,D7                ; error code
             TST.L   D7                   ; ok ?
             BNE.S   FC1464               ; no
             TST.W   $444                 ; fverify, verify required ?
             BEQ.S   FC1464               ; no
             MOVE.W  D3,(A7)              ; number of sectors
             MOVE.W  D5,-(A7)             ; side
             MOVE.W  D6,-(A7)             ; track
             MOVE.W  D4,-(A7)             ; sector
             MOVE.W  $10(A6),-(A7)        ; drive
             CLR.L   -(A7)                ; filler
             MOVE.L  DISK_BUF,-(A7)       ; $16DA - sector buffer         
             JSR     FLOPVER              ; fverify, verify sector
             ADDA.L  #$10,A7              ; correct stack
             MOVE.L  D0,D7                ; error code
             TST.L   D7                   ; ok ?
             BNE.S   FC1464               ; no
             MOVE.L  DISK_BUF,(A7)        ; $16DA - sector buffer   
             BSR     CONV_8086            ; convert 8086 to 68000 int.
             TST.W   D0                   ; bad sector list
             BEQ.S   FC1464               ; sectors ok ?
             MOVEQ   #-$10,D7             ; bad sectors
FC1464       BRA.S   FC14A0
FC1466       MOVE.W  D3,(A7)              ; number of sectors
             MOVE.W  D5,-(A7)             ; side
             MOVE.W  D6,-(A7)             ; track
             MOVE.W  D4,-(A7)             ; sector
             MOVE.W  $10(A6),-(A7)        ; drive
             CLR.L   -(A7)                ; filler 
             MOVE.L  -6(A6),-(A7)         ; sector buffer
             JSR     FLOPRD               ; read sector
             ADDA.L  #$10,A7              ; correct stack
             MOVE.L  D0,D7                ; save error code
             MOVE.L  -6(A6),D0            ; use buffer
             CMP.L   $A(A6),D0            ; equals desired buffer
             BEQ.S   FC14A0               ; yes
             MOVE.L  $A(A6),(A7)          ; source address
             MOVE.L  -6(A6),-(A7)         ; destination
             JSR     COPY_SECT            ; copy sector
             ADDQ.L  #4,A7                ; correct stack
FC14A0       TST.L   D7                   ; test error code
             BGE.S   FC14D6               ; ok ?
             MOVE.W  $10(A6),(A7)         ; drive number
             MOVE.L  D7,D0                ; error code
             MOVE.W  D0,-(A7)             ; on stack
             JSR     EVT_CRITIC           ; critical error handler
             ADDQ.L  #2,A7                ; correct stack
             MOVE.L  D0,D7                ; get error code
             CMPI.W  #2,8(A6)             ; 
             BGE.S   FC14D6               ; 
             CMP.L   #$10000,D7           ; attempt again ?
             BNE.S   FC14D6               ; 
             MOVE.W  $10(A6),(A7)         ; 
             BSR     FC11E4               ; 
             CMP.W   #2,D0                ; 
             BNE.S   FC14D6
             MOVEQ   #-$E,D7
FC14D6       CMP.L   #$10000,D7           ; attempt again ?
             BEQ     FC13DE               ; yes
             TST.L   D7                   ; error code
             BGE.S   FC14E8               ; ok
             MOVE.L  D7,D0                ; error code as result
             BRA.S   FC1506
FC14E8       MOVE.W  D3,D0                ; sector counter
             EXT.L   D0
             MOVEQ   #9,D1                ; times 512
             ASL.L   D1,D0
             ADD.L   D0,$A(A6)            ; increment buffer address
             ADD.W   D3,$E(A6)            ; logical sect. num. plus counter
             SUB.W   D3,$12(A6)           ; dec. num. of sectors to process
FC14FC       TST.W   $12(A6)              ; sectors yet to read / write ?
             BNE     FC137E               ; yes
             CLR.L   D0                   ; ok
FC1506       TST.L   (A7)+
             MOVEM.L (A7)+,D3-D7/A5
             UNLK    A6
             RTS

 ; ************************************************
 ; *** Function Generate Random Number (FC1510) ***
 ; ************************************************

RANDOM:      LINK    A6,#-4
             TST.L   LAST_RND             ; $2A4A last random number
             BNE.S   NOT_ZERO             ; not zero
             MOVE.L  $4BA,D0              ; 200 HZ counter
             MOVEQ   #$10,D1              ; 16 bit shift
             ASL.L   D1,D0                ; bits 0-15 to 16-31
             OR.L    $4BA,D0              ; plus 200 hz counter
             MOVE.L  D0,LAST_RND          ; $2A4A use as start value
NOT_ZERO:    MOVE.L  #$BB40E62D,-(A7)     ; 3141592621
             MOVE.L  LAST_RND,-(A7)       ; $2A4A last random value
             JSR     MUL_32BIT            ; 32 * 32 bit multiplication
             ADDQ.L  #8,A7                ; correct stack
             ADDQ.L  #1,D0                ; result plus 1
             MOVE.L  D0,LAST_RND          ; $2A4A as new start value     
             MOVE.L  LAST_RND,D0          ; $2A4A
             ASR.L   #8,D0                ; bits 31-8 to 23-0
             AND.L   #$FFFFFF,D0          ; 24-bit random number 
             UNLK    A6
             RTS

 ; ***********************************
 ; *** BOOT LOAD function (FC1560) ***
 ; ***********************************

;BOOTLOAD:    LINK    A6,#0
;             MOVEM.L D6-D7,-(A7)
;             JSR     HD_INIT           ; intializate hard disk
;             TST.W   $4A6              ; number of floppy
;             BEQ.S   FC15CA            ; drive not connected ?
;             MOVEQ   #2,D7             ; couldn't load
;             MOVE.W  #1,(A7)           ; one sector
;             CLR.L   -(A7)             ; side 0, track 0
;             MOVE.W  #1,-(A7)          ; sector 1
;             CLR.W   -(A7)             ; boot device as drive number
;             CLR.L   -(A7)             ; filler
;             MOVE.L  DISK_BUF,-(A7)    ; $16DA - sector buffer
;             JSR     FLOPRD            ; read sector
;             ADDA.L  #$10,A7           ; correct stack pointer
;             TST.L   D0                ; error ?
;             BNE.S   FC15BE            ; no
;             CLR.W   D7
;             BRA.S   FC15C8
;FC15BE       TST.B   -$2(A4)           ; $9F8 - write protect status
;             BNE.S   FC15C8           
;             MOVEQ   #3,D0             ; unreadable
;             BRA.S   FC15EE
;FC15C8       BRA.S   FC15CC
;FC15CA       MOVEQ   #1,D7
;FC15CC       TST.W   D7
;             BEQ.S   FC15D2
;             MOVE.W  D7,D0             ; get old error code
;             BRA.S   FC15EE
;FC15D2       MOVE.W  #$100,(A7)        ; $100 words
;             MOVE.L  DISK_BUF,-(A7)    ; $16DA - sector buffer
;             BSR     CHECKSUM          ; calculate checksum
;             ADDQ.L  #4,A7             ; correct stack
;             CMP.W   #$1234,D0         ; comp. with checksum for boot sector
;             BNE.S   FC15EC            ; not equal ?
;             CLR.W   D0                ; ok 
;             BRA.S   FC15EE           
;FC15EC       MOVEQ   #4,D0             ; not valid boot sector
;FC15EE       TST.L   (A7)+
;             MOVEM.L (A7)+,D7          ; restore registers
;             UNLK    A6
;             RTS

 ; ********************************************************
 ; *** PROTOBT FUNCTION - generate boot sector (FC15F8) ***
 ; ********************************************************

PROTOBT:     LINK    A6,#-6
             MOVEM.L D5-D7/A4-A5,-(A7)   
             cmp.w   #1,$E(A4)	; $A08 compire carrent drive number             	
             bne.s   TEST_EXEC
             subq.w  #2,$10(A6)        ; if drive B then disk is $40 track	   
TEST_EXEC:   TST.W   $12(A6)           ; test exec flag
             BGE.S   FC1624            ; maintain executability
             MOVE.W  #$100,(A7)        ; $100 words
             MOVE.L  8(A6),-(A7)       ; address of the sectors buffer
             BSR     CHECKSUM          ; calculate checksum
             ADDQ.L  #4,A7             ; correct stack
             CMP.W   #$1234,D0         ; equals checksum for boot sector
             BEQ.S   BOOT_EXEC         ; yes
             CLR.W   D0                ; not executable
             BRA.S   NOT_EXEC
BOOT_EXEC:   MOVEQ   #1,D0             ; executable
NOT_EXEC:    MOVE.W  D0,$12(A6)        ; execflg to 1=boot sect. executable
FC1624       TST.L   $C(A6)            ; serial number
             BLT.S   FC1668            ; negative, don't change
             MOVE.L  $C(A6),D0         ; serial number
             CMP.L   #$FFFFFF,D0       ; > $FFFFFF ?
             BLE.S   FC163E            ; no
             BSR     RANDOM            ; generate random number
             MOVE.L  D0,$C(A6)         ; save
FC163E       CLR.W   D7                ; clear counter
             MOVEA.L 8(A6),A1          ; plus base address
             MOVE.L  #$EB349000,0(A1)  ; boot sector compatible with IBM
             CLR.L   4(A1)             ; clear next long word
             BRA.S   FC1662
FC1642       MOVE.L  $C(A6),D0         ; random number
             AND.L   #$FF,D0           ; bits 0-7
             MOVEA.W D7,A1             ; pointer to next byte in buffer
             ADDA.L  8(A6),A1          ; plus base address
             MOVE.B  D0,8(A1)          ; write byte of serial num. in buffer
             MOVE.L  $C(A6),D0         ; random number 
             ASR.L   #8,D0             ; in order to shift 8 bits right
             MOVE.L  D0,$C(A6)         ; and save new value
             ADDQ.W  #1,D7             ; increment counter
FC1662       CMP.W   #3,D7             ; three bytes copied already ?
FC1668       BLT.S   FC1642            ; no
             TST.W   $10(A6)           ; diskette size
             BLT.S   FC1696            ; times 19 equals ptr. to prototype BPB
             MOVE.W  $10(A6),D6        ; 
             MULS    #$13,D6
             CLR.W   D7                ; clear counter
             BRA.S   FC1690
FC167A       MOVEA.W D7,A0             ; counter
             ADDA.L  8(A6),A0          ; plus address of the prototype BPB
             MOVEA.W D6,A1             
             ADDA.L  #FD2F32,A1        ; address of the prototype BPB !!!!!!!
             MOVE.B  (A1),$B(A0)       ; copy BPB
             ADDQ.W  #1,D6
             ADDQ.W  #1,D7             ; increment counter
FC1690       CMP.W   #$13,D7           ; already 19 ?
             BLT.S   FC167A            ; no
FC1696       CLR.W   -6(A6)
             MOVE.L  8(A6),-4(A6)      ; buffer address
             BRA.S   FC16B0
FC16A2       MOVEA.L -4(A6),A0
             MOVE.W  (A0),D0           ; get word from buffer
             ADD.W   D0,-6(A6)         ; sum for checksum generation
             ADDQ.L  #2,-4(A6)         ; next word
FC16B0       MOVE.L  8(A6),D0          ; buffer address
             ADD.L   #$1FE,D0          ; plus $1FE
             CMP.L   -4(A6),D0         ; last word already
             BHI.S   FC16A2
             MOVE.W  #$1234,D0         ; checksum for boot sector
             SUB.W   -6(A6),D0         ; subtract from previous value
             MOVEA.L -4(A6),A1
             MOVE.W  D0,(A1)           ; checksum in buffer
             TST.W   $12(A6)           ; exec flag
             BNE.S   FC16DA            ; boot sector executable ?
             MOVEA.L -4(A6),A0         
             ADDQ.W  #1,(A0)           ; increment checksum, not executable
FC16DA       TST.L   (A7)+
             MOVEM.L (A7)+,D6-D7/A4-A5
             UNLK    A6
             RTS

  ; Calculate checksum (FC16E4)
 
CHECKSUM:    LINK    A6,#0
             MOVEM.L D6-D7,-(A7)
             CLR.W   D7                ; clear sum
             BRA.S   FC16FC
FC16F0       MOVEA.L 8(A6),A0          ; address of buffer
             MOVE.W  (A0),D0           ; get word
             ADD.W   D0,D7             ; and sum
             ADDQ.L  #2,8(A6)          ; pointer to next word
FC16FC       MOVE.W  $C(A6),D0         ; number of words
             SUBQ.W  #1,$C(A6)         ; minus 1
             TST.W   D0                ; all words added already
             BNE.S   FC16F0            ; no
             MOVE.W  D7,D0             ; result to D0
             TST.L   (A7)+
             MOVEM.L (A7)+,D7
             UNLK    A6
             RTS

  ; Convert 8086 integer number to 68000 number

CONV_8086:   LINK    A6,#-4
             MOVEA.L 8(A6),A0          ; address of number
             MOVE.B  1(A0),D0          ; get high byte
             EXT.W   D0                ; extend to word
             AND.W   #$FF,D0           ; isolate bits 0-7
             ASL.W   #8,D0             ; shift in position 8-15
             MOVEA.L 8(A6),A1          ; address of the number
             MOVE.B  (A1),D1           ; get low byte
             EXT.W   D1                ; extend to word
             AND.W   #$FF,D1           ; isolate bits 0-7
             OR.W    D1,D0             ; combine with bits 8-15
             UNLK    A6
             RTS

 ; FLOPINI - initialize drive (FC173A)    ???????????????????
                                       ; DSB0 - device status block of
                                       ; floppy#0
FLOPINIT:    MOVEA.L DISK_ARR,A1       ; $A4C dsb0, pointer to DSB drive A
             ADDA.L  #$52,A1           
             TST.W   $C(A7)            ; drive A ?
             BEQ.S   FC174C            ; yes
             MOVEA.L DISK_ARR,A1       ; $A50 dsb1, take DSB from drive B 
             ADDA.L  #$56,A1           
FC174C       MOVE.W  $440,2(A1)        ; seekrate
             MOVEQ   #-1,D0            ; default error number
             CLR.W   0(A1)             ; track number to zero
             BSR     FLOPLOCK          ; set parameters
             BSR     SEL_DRV_SID       ; select drive and side
             MOVE.W  #-$100,0(A1)
             BSR     RESTORE           ; restore
             BEQ.S   FC177A
             MOVEQ   #$A,D7
             mulu.w  HEAD_STEP,D7      ; &&&
             BSR     FC1D2E
             BNE.S   FC177E
             BSR     RESTORE           ; restore
FC177A       BEQ     FLOPOK            ; FLOPOK, no error
FC177E       BRA     FLOPFAIL          ; FLOPFAIL, error

 ; *********************************
 ; *** FLOPRD function ($FC1782) ***
 ; *********************************

FLOPRD:  ;    move.l  A0,SAVE_A0
         ;    move.l  D0,SAVE_D0
             move.l  DSB_B,A0
             move.w  (A0),D0
             lsr.w   #5,D0
             eori.w  #$3,D0
             move.w  D0,HEAD_STEP
       ;      move.l  SAVE_D0,D0
       ;      move.l  SAVE_A0,A0
             BSR     DSK_CHANGE        ; test for disk change
             MOVEQ   #-$B,D0           ; read error number
             BSR     FLOPLOCK          ; floplock, set parameters
READ_ANOTHER:BSR     SEL_DRV_SID       ; select drive & side
             BSR     SEARCH_TRK        ; go2track, search for track
             BNE     SEARCH_ERR        ; try again if search error
FC1798       MOVE.W  #-1,$2C(A4)       ; $A26 current disk error 
                                       ; to default error
             move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             bsr     DISK_CTRL      
             MOVE.W  #$90,(A6)         ; clear DMA status
             MOVE.W  #$190,(A6)
             MOVE.W  #$90,(A6)         ; data direction to READ
             MOVE.W  #1,$FF8604        ; ccount to dskct1, sector counter
             MOVE.W  #$80,(A6)         ; read sector command for 1772
             MOVE.W  #$80,D7           ; read multiple???(see internals)
             BSR     DISK_CTRL         ; wdiskct1,pass D7 to 1772      
             MOVE.L  $4BA,D7   
             ADD.L   #$C8,D7           ; initialize timeout counter
INTER_WAIT:  BTST    #5,$FFFA01        ; MFP gpip, 1772 done ?
             BEQ.S   INTER_END         ; yes
             CMP.L   $4BA,D7             ; decrement timeout counter
             BHI.S   INTER_WAIT        ; timed out ?
             MOVE.W  #-2,$2C(A4)       ; $A26(A5) current error to timeout   
             BSR     RESET_1772        ; reset, end transfer
             BRA.S   SEARCH_ERR        ; start next attempt
INTER_END:   move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             MULU.W  HEAD_STEP,D7
             bsr     DISK_CTRL      
             MOVE.W  #$90,(A6)         ; select DMA status register 
             MOVE.W  (A6),D0           ; read status
             BTST    #0,D0             ; DMA error ?
             BEQ.S   SEARCH_ERR        ; yes, try again
             MOVE.W  #$80,(A6)         ; select 1772 status register
             BSR     DISK_CTRL2        ; RDISKCT1, read register
             AND.B   #$1C,D0           ; RNF, isolate chksum und lost data
             BNE.S   FC181C            ; 
             MOVE.W  #2,-$4(A4)        ; $9F6(A5) disk retry count
             ADDQ.W  #1,$12(A4)        ; $A0C(A5) current sector
             ADDI.L  #$200,$18(A4)     ; $A12(A5) plus sector size
             SUBQ.W  #1,$16(A4)        ; $A10(A5) curr. count of sectors, 
                                       ; dec. attempt counter
             BEQ     FLOPOK            ; no error
             BSR     FC1E3C            ; ERRBITS, determine error number
             BRA     FC1798            
FC181C       BSR.S   FC1836

SEARCH_ERR:  CMPI.W  #1,-$4(A4)        ; $9F6(A5)retrycount to second attempt?
             BNE.S   FC182A            ; no
             BSR     RESEEK            ; reseek, home & reseek
FC182A       BSR     RESTORE           ; set head to track 0
             SUBQ.W  #1,-$4(A4)        ; $9F6(A5) retrycount, dec. attempt 
                                       ; counter
             BPL     READ_ANOTHER      ; another attempt ?
             BRA     FLOPFAIL          ; no, flopfail

  ; ERRBITS, 1772 Status in Error Number

FC1836       MOVEQ   #-$D,D1           ; write protect ?
             BTST    #6,D0             
             BNE.S   FC1852            ; yes
             MOVEQ   #-8,D1            ; record not found ?
             BTST    #4,D0
             BNE.S   FC1852            ; yes
             MOVEQ   #-4,D1            ; CRC error ?
             BTST    #3,D0
             BNE.S   FC1852            ; no
             MOVE.W  $2A(A4),D1        ; $A24(A5) take default disk error
FC1852       MOVE.W  D1,$2C(A4)        ; $A26(A5) as current disk error
             RTS

 ; ***********************
 ; *** FLOPWR function ***
 ; ***********************

FLOPWR  ;     move.l  A0,SAVE_A0
        ;     move.l  D0,SAVE_D0
             move.l  DSB_B,A0
             move.w  (A0),D0
             lsr.w   #5,D0
             eori.w  #$3,D0
             move.w  D0,HEAD_STEP
       ;      move.l  SAVE_D0,D0
       ;      move.l  SAVE_A0,A0
             BSR     DSK_CHANGE        ; test for disk change
             MOVEQ   #-$A,D0           ; default error to write error
             BSR     FLOPLOCK          ; set parameters
             MOVE.W  $12(A4),D0        ; $A0C(A5) current sector number 1 ?      
             SUBQ.W  #1,D0            
             OR.W    $10(A4),D0        ; $A0A(A5) current track number 0 ?
             OR.W    $14(A4),D0        ; $A0E(A5) current side 0 ?
             BNE.S   FC1878            ; no, not boot sector
             MOVEQ   #2,D0             ; media change
             BSR     FC1EF6            ; set to unsure
FC1878       BSR     SEL_DRV_SID       ; select drive and side
             BSR     SEARCH_TRK        ; search for track
             BNE     FC1906            ; error, try again
FC1884       MOVE.W  #-1,$2C(A4)       ; $A26(A5) current error to default   
             move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             bsr     DISK_CTRL      
             MOVE.W  #$190,(A6)        ; clear DMA status
             MOVE.W  #$90,(A6)         
             MOVE.W  #$190,(A6)        ; data direction to write
             MOVE.W  #1,D7             ; sector count register
             BSR     DISK_CTRL         ; wdiskct1, D7 to 1772
             MOVE.W  #$180,(A6)        ; select 1772
             MOVE.W  #$A0,D7           ; write sector
             BSR     DISK_CTRL         ; wdiskct1, D7 to 1772
             MOVE.L  $4BA,D7           ; timeout counter
             ADD.L   #$C8,D7
FC18B0       BTST    #5,$FFFA01        ; MFP, gpip, 1772 done ?
             BEQ.S   FC18C4            ; yes
             CMP.L   $4BA,D7           ; decrement timeout counter
             BHI.S   FC18B0            ; not timed out yet ?
             BSR     RESET_1772        ; reset, end transfer
             BRA.S   FC18FE          
FC18C4       move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             MULU.W  HEAD_STEP,D7
             bsr     DISK_CTRL      
             MOVE.W  #$180,(A6)        ; select 1772 status register
             BSR     DISK_CTRL2        ; rdiskct1, read 1772 registers
             BSR     FC1836            ; errbits, calculate error number
             BTST    #6,D0             ; write protect ?
             BNE     FLOPFAIL          ; no further attempt
             AND.B   #$5C,D0           ; write protect, RNF, checksum and
                                       ; lost data
             BNE.S   FC18FE            ; error, try again
             MOVE.W  #2,-$4(A4)        ; $9F6(A5) disk retry counter
             ADDQ.W  #1,$12(A4)        ; $A0C(A5) inc. current sector 
             ADDI.L  #$200,$18(A4)     ; $A12(A5) cdma, DMA address to next
                                       ; sector
             SUBQ.W  #1,$16(A4)        ; $A10(A5) dec. counter of sectors
             BEQ     FLOPOK            ; all sectors, then done
             BSR     FC1E3C            ; select1,sect. num. and DMA pointer
             BRA     FC1884            ; write next sector without seek

FC18FE       CMPI.W  #1,-$4(A4)        ; $9F6(A5)retrycount,second attempt ?
             BNE.S   FC190A            ; no
FC1906       BSR     RESEEK            ; reseek, home and seek
FC190A       BSR     RESTORE           ; set head to track 0
             SUBQ.W  #1,-$4(A4)        ; $9F6(A5) retry counter, decrement 
                                       ; attempt counter
             BPL     FC1878            ; another attempt ?
             BRA     FLOPFAIL          ; floppy fail error

 ; ************************
 ; *** FLOPFMT function ***
 ; ************************

FLOPFMT      CMPI.L  #$87654321,$16(A7) ; magic number ?
             BNE     FLOPFAIL           ; no, floppy fail
             move.w  #2,HEAD_STEP         ; set head step
             btst    #0,$10(A7)         ; test for evet track
             beq.s   CONT_FMT           ; if track not even then quit
             clr.l   d0
             rts
CONT_FMT:    lsr.w   $10(A7)            ; else track=track/2 
             BSR     DSK_CHANGE         ; test for disk change
             MOVEQ   #-1,D0             ; default error number
             BSR     FLOPLOCK           ; set parameters
             BSR     SEL_DRV_SID        ; select drive and side
             MOVE.W  $E(A7),SECT_TRK    ; $A16(A5) spt, sectors per track
             MOVE.W  $14(A7),INTERLV    ; $A18(A5) interlv, interleave factor
             MOVE.W  $1A(A7),VIRGIN     ; $A1A(A5) virgin, sector data for 
                                        ; formatting
             MOVE.L  8(A7),VAR          ; $A1C(A5) 
             MOVEQ   #2,D0              ; changed
             BSR     FC1EF6             ; disk changed
             BSR     SET_HEAD           ; hseek, search for track
             BNE     FLOPFAIL           ; not found
             MOVE.W  $10(A4),0(A1)      ; $A0A(A5) ctrack, write current 
                                        ; track in DSB
             MOVE.W  #-1,$2C(A4)        ; $A26(A5) currerr to default error
             move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             bsr     DISK_CTRL      
             BSR.S   FMT_TRK            ; format track
             BNE     FLOPFAIL           ; floppy fail, error
             MOVE.W  SECT_TRK,$16(A4)   ; $A16(A5),$A10(A5) spt sectors per
                                        ; track as current counter
             MOVE.W  #1,$12(A4)         ; $A0C(A5) csect, start with sector 1
             move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             bsr     DISK_CTRL      
             BSR     VER_SECT           ; verify, verify sector
             MOVEA.L $18(A4),A2         ; $A12(A5) cdma, list with bad sector
             TST.W   (A2)               ; bad sector ?
             BEQ     FLOPOK             ; no
             MOVE.W  #-$10,$2C(A4)      ; $A26(A5) currerr to bad sector
             BRA     FLOPFAIL           ; floppy fail, error

 ; FMTACK - Format Track

FMT_TRK:     MOVE.W  #-$A,$2A(A4)       ; $A24(A5) deferror,default error num
             MOVEA.L $18(A4),A2         ; $A12(A5) cdma, buf. for track data
             MOVEA.L VAR,A3             ; $A1C(A5) 
             MOVE.W  #$3B,D1            ; 60 times
             MOVE.B  #$4E,D0            ; $4E - track header
             BSR     FC1ADA             ; wmult, write in buffer
             CLR.W   D3                 
             TST.W   INTERLV            ; $A18(A5)
             BMI     FC1AA8              
             MOVE.W  #1,D3              ; start with sector 1
FC19B4       MOVE.W  D3,D4              ; save sector number
FC19B6       MOVE.W  #$B,D1             ; 12 times
             CLR.B   D0                 ; 0
             BSR     FC1ADA             ; wmult, write in buffer
             MOVE.W  #2,D1              ; 3 times
             MOVE.B  #-$B,D0            ; $F5
             BSR     FC1ADA             ; wmult, write in buffer
             MOVE.B  #-2,(A2)+          ; $FE address mark
             MOVE.B  $11(A4),(A2)+      ; $A0B track
             MOVE.B  $15(A4),(A2)+      ; $A0F side
             MOVE.B  D4,(A2)+           ; sector
             MOVE.B  #2,(A2)+           ; sector size (512 bytes)
             MOVE.B  #-9,(A2)+          ; $F7 write checksum
             MOVE.W  #$15,D1            ; 22 times
             MOVE.B  #$4E,D0            ; $4E
             BSR     FC1ADA             ; wmult, write in buffer
             MOVE.W  #$B,D1             ; 12 times
             CLR.B   D0                 ; 0
             BSR     FC1ADA             ; wmult, write in buffer
             MOVE.W  #2,D1              ; 3 times
             MOVE.B  #-$B,D0            ; $F5
             BSR     FC1ADA             ; wmult, write in buffer
             MOVE.B  #-5,(A2)+          ; $FB, data block mark
             MOVE.W  #$FF,D1            ; 256 times
FC1A10       MOVE.B  VIRGIN,(A2)+       ; $A1A(A5) virgin, initial data     
             MOVE.B  VIRGIN_1,(A2)+     ; $A1B(A5) in buffer
             DBRA    D1,FC1A10          ; next word
             MOVE.B  #-9,(A2)+          ; $F7 write checksum
             MOVE.W  #$27,D1            ; 40 times
             MOVE.B  #$4E,D0            ; $4E
             BSR     FC1ADA             ; wmult, write in buffer
             TST.W   INTERLV            ; $A18(A5)     
             BMI     FC1AA8             ; 
             ADD.W   INTERLV,D4         ; $A18(A5) add interlv, next sector
             CMP.W   SECT_TRK,D4        ; $A16(A5) spt, largest sect. num. ?
             BLE     FC19B6             ; no, next sector 
             ADDQ.W  #1,D3              ; start sector plus one
             CMP.W   INTERLV,D3         ; $A18(A5) interlv
             BLE     FC19B4             ; next sector
FC1A48       MOVE.W  #$578,D1           ; 1401 times (until track end)
             MOVE.B  #$4E,D0            ; $4E
             BSR     FC1ADA             ; wmult, write in buffer
             MOVE.B  $1B(A4),$FF860D    ; $A15(A5) dmalow
             MOVE.B  $1A(A4),$FF860B    ; $A14(A5) dmamid
             MOVE.B  $19(A4),$FF8609    ; $A13(A5) dmahigh
             MOVE.W  #$190,(A6)         ; clear DMA status
             MOVE.W  #$90,(A6)
             MOVE.W  #$190,(A6)         ; data direction to WRITE
             MOVE.W  #$1F,D7            ; sector counter to 31
             BSR     DISK_CTRL          ; wdiskct1, D7 to 1772
             MOVE.W  #$180,(A6)         ; select 1772
             MOVE.W  #$F0,D7            ; format track command
             BSR     DISK_CTRL          ; wdiskct1, D7 to 1772
             MOVE.L  $4BA,D7            ; timeout counter
             ADD.L   #$C8,D7
FC1A92       BTST    #5,$FFFA01         ; MFP gpip, 1772 done ?
             BEQ.S   FC1ABC             ; yes
             CMP.L   $4BA,D7            ; decrement timeout counter
             BHI.S   FC1A92             ; not yet timed out ?
             BSR     RESET_1772         ; reset, terminate
FC1AA4       MOVEQ   #1,D7              ; clear Z-bit, error
             RTS

FC1AA8       CMP.W   SECT_TRK,D3         ; $A16(A5) 
             BEQ.S   FC1A48             
             MOVE.W  D3,D6              
             ADD.W   D6,D6              
             MOVE.W  0(A3,D6.W),D4      
             ADDQ.W  #1,D3
             BRA     FC19B6

FC1ABC       MOVE.W  #$190,(A6)         ; select DMA status
             MOVE.W  (A6),D0            ; read status
             BTST    #0,D0              ; DMA error ?
             BEQ.S   FC1AA4             ; yes
             MOVE.W  #$180,(A6)         ; select 1772 status register
             BSR     DISK_CTRL2         ; read registers
             BSR     FC1836             ; errbits, calculate error number
             AND.B   #$44,D0            ; test write protect and lost data
             RTS

FC1ADA       MOVE.B  D0,(A2)+           ; write data in buffer
             DBRA    D1,FC1ADA          ; next byte
             RTS

 ; ******************************** 
 ; *** FLOPPY VERIFY SUBROUTINE ***
 ; ********************************

FLOPVER:     BSR     DSK_CHANGE        ; test for disk change
             MOVEQ   #-$B,D0           ; read error, as default error
             BSR     FLOPLOCK          ; set parameters
             BSR     SEL_DRV_SID       ; select
             BSR     SEARCH_TRK        ; search for track
             BNE     FLOPFAIL          ; floppy fail error
             BSR.S   VER_SECT          ; verify1, verify sectors
             BRA     FLOPOK            ; done

VER_SECT:    MOVE.W  #-$B,$2A(A4)      ; $A24(A5) deferror to read error
             MOVEA.L $18(A4),A2        ; $A12(A5) cdma, DMA buffer for 
                                       ; bad sector list
             ADDI.L  #$200,$18(A4)     ; $A12(A5) cdma to next sector
FC1B10       MOVE.W  #2,-$4(A4)        ; $9F6(A5) retrycnt, 2 attempts
             MOVE.W  #$84,(A6)         ; select sector register
             MOVE.W  $12(A4),D7        ; $A0C(A5) csect, sector number
             BSR     DISK_CTRL         ; wdiskct1, to disk controller
FC1B22       MOVE.B  $1B(A4),$FF860D   ; $A15(A5) dmalow
             MOVE.B  $1A(A4),$FF860B   ; $A14(A5) dmamid
             MOVE.B  $19(A4),$FF8609   ; $A13(A5) dmahigh
             move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             bsr     DISK_CTRL      
             MOVE.W  #$90,(A6)         ; clear DMA status
             MOVE.W  #$190,(A6)        
             MOVE.W  #$90,(A6)         ; data direction to read
             MOVE.W  #1,D7             ; sector counter to 1
             BSR     DISK_CTRL         ; wdiskct1
             MOVE.W  #$80,(A6)         ; select 1772 command register
             MOVE.W  #$80,D7           ; read sector command
             BSR     DISK_CTRL         ; wdiskct1
             MOVE.L  $4BA,D7           ; timeout counter
             ADD.L   #$C8,D7
FC1B60       BTST    #5,$FFFA01        ; MFP gpip, 1772 done ?
             BEQ.S   FC1B74            ; yes
             CMP.L   $4BA,D7           ; decrement timeout counter
             BHI.S   FC1B60            ; timed out yet ?
             BSR     RESET_1772        ; reset 1772
             BRA.S   FC1BAA            ; next attempt
FC1B74       move.w  #$82,(a6)         ; &&&
             move.w  $10(a4),d7
             MULU.W  HEAD_STEP,D7
             bsr     DISK_CTRL      
             MOVE.W  #$90,(A6)         ; select DMA status register 
             MOVE.W  (A6),D0           ; read status
             BTST    #0,D0             ; DMA error ?
             BEQ.S   FC1BAA            ; yes, try again
             MOVE.W  #$80,(A6)         ; select 1772 status register
             BSR     DISK_CTRL2        ; rdiskct1, read status
             BSR     FC1836            ; errbits, calculate error number
             AND.B   #$1C,D0           ; test RNF, CRC and lost data
             BNE.S   FC1BAA            ; error, next attempt
FC1B92       ADDQ.W  #1,$12(A4)        ; $A0C(A5) csect, next sector ?
             SUBQ.W  #1,$16(A4)        ; $A10(A5) ccount, dec. sect. counter
             BNE     FC1B10            ; another sector ?
             SUBI.L  #$200,$18(A4)     ; $A12(A5) cdma, reset DMA pointer
             CLR.W   (A2)              ; bad sector list mit null abschlien
             RTS

FC1BAA       CMPI.W  #1,-$4(A4)        ; $9F6(A5) retrycnt, 2ns attempt ?
             BNE.S   FC1BB6            ; no
             BSR     RESEEK            ; reseek
FC1BB6       BSR     RESTORE           ; set head to track 0
             SUBQ.W  #1,-$4(A4)        ; $9F6(A5) decrement retrycnt
             BPL     FC1B22            ; another attempt ?
             MOVE.W  $12(A4),(A2)+     ; $A0C(A5) csect, sector number in 
                                       ; bad sector list
             BRA.S   FC1B92            ; next sector

 ; FLOPVBL - Floppy Vertical Blank Handler

             MOVEA.L DISK_ARR,A4
	SUBA.L  A5,A5             ; clear A5
             LEA     $FF8606,A6        ; address of floppy register
             ST.B    $A(A4)            ; $A04(A5) set motoron flag 
             TST.W   $43E(A5)          ; floppy lock, disks busy ?
             BNE.S   FC1C46            ; yes, do nothing
             MOVE.L  $466(A5),D0       ; _FRCLOCK
             MOVE.B  D0,D1
             AND.B   #7,D1             ; calculate mod 8
             BNE.S   FC1C1C            ; not yet 8th interrupt ?
             MOVE.W  #$80,(A6)         ; select 1772 status register
             LSR.B   #3,D0             ; use bit 4 as drive number
             AND.W   #1,D0             
             LEA     -$2(A4),A0        ; $9F8(A5) wpstatus, write protect
                                       ; status table
             ADDA.W  D0,A0             ; index with drive number
             CMP.W   $4A6(A5),D0       ; number of floppies
             BNE.S   FC1BFE
             CLR.W   D0
FC1BFE       ADDQ.B  #1,D0             ; drive select bit
             LSL.B   #1,D0             ; shift in position
             EORI.B  #7,D0             ; invert for hardware
             BSR     SET_PORT_A        ; select drive
             MOVE.W  $FF8604,D0        ; dskct1, read 1772 status
             BTST    #6,D0             ; test write protect bit
             SNE.B   (A0)              ; and save
             MOVE.B  D2,D0             ; previous select status
             BSR     SET_PORT_A        ; recreate
FC1C1C       MOVE.W  -$2(A4),D0        ; $9F8(A5) write protect status
             OR.W    D0,$0(A4)         ; $9FA(A5) write status of diskch.
             TST.W   $C(A4)            ; $A06(A5) deslflg, floppies already
                                       ; deselected ?
             BNE.S   FC1C42            ; yes
             BSR     DISK_CTRL2        ; read 1772 status register
             BTST    #7,D0             ; motor on bit set ?
             BNE.S   FC1C46            ; yes, then don's deselect
             MOVE.B  #7,D0             ; both drives
             BSR     SET_PORT_A        ; deselect
             MOVE.W  #1,$C(A4)         ; $A06(A5) set deslflg
FC1C42       CLR.W   $A(A4)            ; $A04(A5) clear motoron flag
FC1C46       RTS

 ; ************************** 
 ; *** FLOP LOCK function ***
 ; **************************

FLOPLOCK:    MOVEM.L D3-D7/A3-A6,SAVE_REG  ; $A28 ???????
             MOVEA.L DISK_ARR,A4
             SUBA.L  A5,A5             ; clear A5
             LEA     $FF8606,A6        ; address of the floppy register
             ST.B    $A(A4)            ; $A04 set motoron flag
             MOVE.W  D0,$2A(A4)        ; $A24(A5) deferror
             MOVE.W  D0,$2C(A4)        ; $A26(A5) currerr
             MOVE.W  #1,$43E(A5)       ; FLOCK, disable floppy-vbl routine
             MOVE.L  8(A7),$18(A4)     ; $A12(A5) cdma
             MOVE.W  $10(A7),$E(A4)    ; $A08(A5) cdev
             MOVE.W  $12(A7),$12(A4)   ; $A0C(A5) csect
             MOVE.W  $14(A7),$10(A4)   ; $A0A(A5) ctrack
             MOVE.W  $16(A7),$14(A4)   ; $A0E(A5) cside
             MOVE.W  $18(A7),$16(A4)   ; $A10(A5) ccount
             MOVE.W  #2,-$4(A4)        ; $9F6(A5) retrycnt
             LEA     $52(A4),A1        ; $A4C(A5) dsb0
             TST.W   $E(A4)            ; $A08(A5) cdev
             BEQ.S   FC1CA4            ; drive 0 ?
             LEA     $56(A4),A1        ; $A50(A5) dsb1
FC1CA4       TST.W   0(A1)             ; dcurtrackm, current track
             BPL.S   FC1CCA            ; >=0 ?
             BSR     SEL_DRV_SID       ; no, select
             CLR.W   0(A1)             ; set track to zero
             BSR     RESTORE           ; rstore, head to track zero
             BEQ.S   FC1CCA            ; ok ?
             MOVEQ   #$A,D7
             MULU.W  HEAD_STEP,D7      ; &&&
             BSR     FC1D2E            ; seek track 10
             BNE.S   FC1CC4            ; error ?
             BSR     RESTORE           ; restore
             BEQ.S   FC1CCA            ; ok ?
FC1CC4       MOVE.W  #-$100,0(A1)      ; recalibrate, error
FC1CCA       RTS

 ; FLOPFAIL - error in floppy routine

FLOPFAIL:    MOVEQ   #1,D0             ; media change to unsure
             BSR     FC1EF6            ; set
             MOVE.W  $2C(A4),D0        ; $A26(A5) currerr
             EXT.L   D0
             BRA.S   FC1CDC

 ; FLOPOK - error free floppy routine

FLOPOK:      CLR.L   D0                
FC1CDC       MOVE.L  D0,-(A7)          ; ok
             MOVE.W  #$86,(A6)         ; select 1772
             MOVE.W  0(A1),D7          ; get track number
             MULU.W  HEAD_STEP,D7      ; &&&
             BSR     DISK_CTRL         ; wdiskct1, send to disk conroller
             MOVE.W  #$10,D6           ; seek command
             BSR     FLOPPY_CMD        ; flopcms
             MOVE.W  $E(A4),D0         ; $A08 cdev, drive number
             LSL.W   #2,D0             ; as index
             MOVEA.L DISK_ARR,A0       ; $9FC acctim
             ADDQ.L  #$2,A0            ; 
             MOVE.L  $466,0(A0,D0.W)   ; 200hz counter as last access time
             CMPI.W  #1,$4A6           ; number of floppy
             BNE.S   FC1D16            
             MOVE.L  $466,4(A0)        ; 200hz counter for other drives
FC1D16       MOVE.L  (A7)+,D0          ; restore error number
             MOVEM.L SAVE_REG,D3-D7/A3-A6  ; $A28
             CLR.W   $43E              ; clear FLOCK, release vbl routine
             RTS

  ; HSEEK - set head to track ($FC1D28)

SET_HEAD:    MOVE.W  $10(A4),D7        ; $A0A ctrack
             MULU.W  HEAD_STEP,D7      ; &&&
FC1D2E       MOVE.W  #-6,$2C(A4)       ; $A26 currerr to seek error
             MOVE.W  #$86,(A6)         ; pass track number
             BSR     DISK_CTRL         ; wdiskct1
             MOVE.W  #$10,D6           ; seek command
             Bsr     FLOPPY_CMD        ; flopcmds
             move.w  sr,SAVE_SR
             move.w  #$82,(a6)
	move.w  $10(a4),d7
	bsr     DISK_CTRL
             move.w  SAVE_SR,sr
             rts
            
  ; RESEEK - home & seek track ($FC1D46)

RESEEK:      MOVE.W  #-6,$2C(A4)       ; $A26 currerr to seek error 
             BSR.S   RESTORE           ; restore
             BNE.S   SEARCH_RET        ; error ?
             CLR.W   0(A1)             ; current track to zero
             MOVE.W  #$82,(A6)         ; select track register
             CLR.W   D7                ; track zero
             BSR     DISK_CTRL         ; wdiskct1
             MOVE.W  #$86,(A6)         ; select data register
             MOVE.W  #5,D7             ; track 5
             MULU.W  HEAD_STEP,D7      ; &&&
             BSR     DISK_CTRL         ; wdiskct1
             MOVE.W  #$10,D6           ; seek command
             BSR.S   FLOPPY_CMD        ; flopcmds
             move.w  sr,SAVE_SR
             move.w  #$82,(a6)         ; &&&
	move.w  #5,d7
	bsr     DISK_CTRL
             move.w  SAVE_SR,sr
             BNE.S   SEARCH_RET        ; error
             MOVE.W  #5,0(A1)          ; track number to 5
   
  ; Search for track (go2track)

SEARCH_TRK:  MOVE.W  #-6,$2C(A4)       ; $A26 currerr to seek error
             MOVE.W  #$86,(A6)         ; select data register
             MOVE.W  $10(A4),D7        ; $A0A(A5) ctrack, load track number
             MULU.W  HEAD_STEP,D7      ; &&&
             BSR     DISK_CTRL         ; wdiskct1
             MOVEQ   #$10,D6           ; seek with verify command
             BSR.S   FLOPPY_CMD        ; flopcmds
             BNE.S   SEARCH_RET        ; error
             MOVE.W  $10(A4),0(A1)     ; $A0A(A5) ctrack, save track number
             AND.B   #$18,D7           ; test RNF, CRC lost data
SEARCH_RET:  RTS

  ; restore, seek track zero ($FC1DA0)

RESTORE:     CLR.W   D6                ; restore command
             BSR.S   FLOPPY_CMD        ; flopcmds
             BNE.S   RESTORE_RET       ; error
             BTST    #2,D7             ; test track zero bit
             EORI.B  #4,CCR            ; Z-flag invertieren
             BNE.S   RESTORE_RET       ; nicht track null ?
             CLR.W   0(A1)             ; current track auf null
RESTORE_RET: RTS

  ; FLOPCMDS - set floppy commands

FLOPPY_CMD:  MOVE.W  2(A1),D0          ; seek rate
             AND.B   #3,D0             ; bits 0 and 1
             OR.B    D0,D6             ; or in command word
             MOVE.L  $4BA,D7           ; timeout counter
             ADD.L   #$C8,D7
             MOVE.W  #$80,(A6)         ; select 1772 register
             BSR     DISK_CTRL2        ; rdiskct1
             BTST    #7,D0             ; motor on ?
             BNE.S   FC1DDA            ; yes
             MOVE.L  $4BA,D7           ; else longer timeout
             ADD.L   #$190,D7
FC1DDA       BSR     DISK_CTRL0        ; wdiskct16, write command in D6
WAIT_INTER:  CMP.L   $4BA,D7           ; decrement timeout counter 
             BCS.S   RESET_CTRL        ; timeout ?
             BTST    #5,$FFFA01        ; MFP gpip, 1772 done ?
             BNE.S   WAIT_INTER        ; no, wait
             BSR     DISK_CTRL1        ; rdiskct17
             CLR.W   D6                ; ok
             RTS

RESET_CTRL:  BSR.S   RESET_1772        ; reset 1772
             MOVEQ   #1,D6             ; error 
             RTS

  ; reset floppy controller

RESET_1772:  MOVE.W  #$80,(A6)         ; select command register
             MOVE.W  #$D0,D7           ; reset command
             BSR     DISK_CTRL         ; wdiskct1
             MOVE.W  #$F,D7            ; delay counter
DELAY_LOOP:  DBRA    D7,DELAY_LOOP     ; timed-out ? read status
             BSR     DISK_CTRL1
             RTS

   ; Select Drive & Side function

SEL_DRV_SID: CLR.W   $C(A4)            ; $A06(A5) clear deslflg
             MOVE.W  $E(A4),D0         ; $A08(A5) cdev, drive number
             ADDQ.B  #1,D0
             LSL.B   #1,D0             ; calculate bit number
             OR.W    $14(A4),D0        ; $A0E(A5) cside, side in bit 0
             EORI.B  #7,D0             ; invert bits for hardware
             AND.B   #7,D0
             BSR.S   SET_PORT_A        ; set bits in sound chip
             MOVE.W  #$82,(A6)         ; select track register
             MOVE.W  0(A1),D7          ; get track number
             MULU.W  HEAD_STEP,D7      ; &&&
             BSR.S   DISK_CTRL         ; wdskct1
             CLR.B   $26(A4)           ; $A20(A5) tmpdma, clear bits 24-31
FC1E3C       MOVE.W  #$84,(A6)         ; select sector register
             MOVE.W  $12(A4),D7        ; $A0C(A5) csect, get sector number
             BSR.S   DISK_CTRL         ; wdiskct1
             MOVE.B  $1B(A4),$FF860D   ; $A15(A5) set DMA base address, low
             MOVE.B  $1A(A4),$FF860B   ; $A14(A5) mid
             MOVE.B  $19(A4),$FF8609   ; $A13(A5) high
             RTS

  ; set port A in sound chip

SET_PORT_A:  MOVE.W  SR,-(A7)          ; save status
             ORI.W   #$700,SR          ; IPL 7
             MOVE.B  #$E,$FF8800       ;
             MOVE.B  $FF8800,D1        ; read port A
             MOVE.B  D1,D2             ; and to D20069AA C23C00F8
             AND.B   #-8,D1            ; clear bits 0-2
             OR.B    D0,D1             ; set new bits
             MOVE.B  D1,$FF8802        ; write result to port A
             MOVE.W  (A7)+,SR          ; restore status
             RTS

 ; wdiskct6

DISK_CTRL0:  BSR.S   WAIT_1772         ; delay loop for disk controller
             MOVE.W  D6,$FF8604        ; dskct1
             BRA.S   WAIT_1772         ; delay loop for disk controller

 ; wdiskct1

DISK_CTRL:   BSR.S   WAIT_1772         ; delay loop for disk controller
             MOVE.W  D7,$FF8604        ; dskct1
             BRA.S   WAIT_1772         ; delay loop for disk controller 

 ; rdiskct7

DISK_CTRL1:  BSR.S   WAIT_1772         ; delay loop for disk controller
             MOVE.W  $FF8604,D7        ; dskct1
             BRA.S   WAIT_1772         ; delay loop for disk controller

 ; rdiskct1

DISK_CTRL2:  BSR.S   WAIT_1772         ; delay loop for disk controller
             MOVE.W  $FF8604,D0        ; dskct1
WAIT_1772:   MOVE.W  SR,-(A7)          ; save status
             MOVE.W  D7,-(A7)          ; save D7
             MOVE.W  #$20,D7           ; counter
WAIT_LOOP:   DBRA    D7,WAIT_LOOP      ; delay loop 
             MOVE.W  (A7)+,D7          ; D7 back
             MOVE.W  (A7)+,SR          ; status back
             RTS

  ; Test Disk Change ($FC1EBE)

DSK_CHANGE:  CMPI.W  #1,$4A6           ; floppy number
             BNE.S   RET_CHG           ; none or 2 floppies, done
             MOVE.W  $10(A7),D0        ; get drive number
             CMP.W   DSK_NUM,D0          ; equals disk number ?   $7DC4
             BEQ.S   DSK_CHG           ; if yes, then return
             MOVE.W  D0,-(A7)          ; save drive number
             MOVE.W  #-$11,-(A7)       ; "insert disk"
             BSR     EVT_CRITIC        ; CRITICAL ERROR HANDLER
             ADDQ.W  #4,A7             ; correct stack pointer
             MOVE.W  #$FFFF,$0(A4)     ; $9FA wplatch, status for both
                                       ; drives unsure
             LEA     $2(A4),A0
             CLR.L   (A0)+
	CLR.L   (A0)
             MOVE.W  $10(A7),DSK_NUM   ; save disk number       $7DC4
DSK_CHG:     CLR.W   $10(A7)           ; drive number to zero
RET_CHG:     RTS

 ; SETDMODE - set drive change mode

FC1EF6       MOVEA.L BPB,A0            ; $755A- disk mode table
             SUBA.L  #$16,A0          
             MOVE.B  D0,-(A7)          ; save mode
             MOVE.W  $E(A4),D0         ; $A08(A5) cdev, get drive number
             MOVE.B  (A7)+,0(A0,D0.W)  ; set drive mode
             RTS

  ; Event Critic Handler

EVT_CRITIC:  MOVE.L  $404,-(A7)        ; move EVT_CRITIC vector to stack
             MOVEQ   #-1,D0            
             RTS                       ; jump to EVT_CRITIC

 ; 32 * 32 Bit integer number multiplication

MUL_32BIT:   LINK    A6,#-4
             CLR.W   D2
             TST.L   8(A6)
             BGE.S   FC4B3A
             NEG.L   8(A6)
             ADDQ.W  #1,D2
FC4B3A       TST.L   $C(A6)
             BGE.S   FC4B46
             NEG.L   $C(A6)
             ADDQ.W  #1,D2
FC4B46       MOVE.W  $A(A6),D0
             MULU    $E(A6),D0
             MOVE.L  D0,-4(A6)
             MOVE.W  8(A6),D0
             MULU    $E(A6),D0
             MOVE.W  $C(A6),D1
             MULU    $A(A6),D1
             ADD.W   D1,D0
             ADD.W   -4(A6),D0
             MOVE.W  D0,-4(A6)
             MOVE.L  -4(A6),D0
             BTST    #0,D2
             BEQ.S   FC4B78
             NEG.L   D0
FC4B78       UNLK    A6
             RTS

 SECTION DATA

PRG_LENGTH:  DC.L    0
BPB:         DC.L    0
DSB_B:       DC.L    0
DISK_ARR:    DC.L    0
SAVESTACK:   DC.L    0
DISK_BUF:    DC.L    0
OLD_XBIOS:   DC.L    0
OLD_HDV_RW:  DC.L    0
SAVE_REG:    DS.L    10
ACCTIM:      DC.L    $12C
LAST_RND:    DC.L    0
DSK_NUM:     DC.W    0
SECT_TRK:    DC.W    0
INTERLV:     DC.W    0
VIRGIN:      DC.B    $E5
VIRGIN_1:    DC.B    $E5
VAR:         DC.L    0
SAVE_SR:     DC.W    0
SAVE_A0:     DC.L    0
SAVE_D0:     DC.L    0
HEAD_STEP:   DC.W    0
PROTECT:     DC.L    0
 ; 40 track SS

FD2F32:      DC.B    $00,$02     ; bytes per sector    
             DC.B    $01         ; sectors per cluster
             DC.B    $01,$00     ; number of reserved disk sectors
             DC.B    $02         ; number of FAT
             DC.B    $40,$00     ; number of directory entries
             DC.B    $68,$01     ; number of sectors on disk
             DC.B    $FC         ; media descriptor byte (not used on ST)
             DC.B    $02,$00     ; sectors per FAT 
             DC.B    $09,$00     ; sectors per track
             DC.B    $01,$00     ; number of sides
             DC.B    $00,$00     ; number of hidden sectors
  
 ; 40 track DS

             DC.B    $00,$02
             DC.B    $02
             DC.B    $01,$00
             DC.B    $02
             DC.B    $70,$00
             DC.B    $D0,$02
             DC.B    $FD
             DC.B    $02,$00
             DC.B    $09,$00
             DC.B    $02,$00
             DC.B    $00,$00

 ; 80 track SS
 
             DC.B    $00,$02
             DC.B    $02
             DC.B    $01,$00
             DC.B    $02
             DC.B    $70,$00
             DC.B    $D0,$02
             DC.B    $F8
             DC.B    $05,$00
             DC.B    $09,$00
             DC.B    $01,$00
             DC.B    $00,$00

 ; 80 track DS

             DC.B    $00,$02
             DC.B    $02
             DC.B    $01,$00
             DC.B    $02
             DC.B    $70,$00
             DC.B    $A0,$05
             DC.B    $F9
             DC.B    $05,$00
             DC.B    $09,$00
             DC.B    $02,$00
             DC.B    $00,$00

             DC.B    $0F,$0F,$0D,$06,$09,$06,$08,$06,$08,$02,$08,$00
             DC.B    $08,$00,$08,$00,$00,$00
             
BEG_MESSAGE: DC.B    27,'c',3,27,'E',27,'b',2,27,'Y'
             DC.B    32+11  
COLUMN:      DC.B    32+23
             DC.B    "40 Track Disk Driver For Drive B",10,13
             DC.B    27,'Y'
             DC.B    32+12
COLUMN_1:    DC.B    32+25
NAME:        DC.B    "By Karpow Boris (Version 1.0)",10,13,0
RESTORE_COL: DC.B    27,'c',0,27,'b',1,27,'E',0
WARNING_MESS:DC.B    27,'E',"Insert Disk in Drive A and Press a Key",10,13
             DC.B    "Or ESC key for Exit",10,13,0

 SECTION BSS

             DS.L    200
PRG_STACK:   DS.L    0 

 END

?
